## dde-control-center 6.1.38

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(DVERSION "6.0.44" CACHE STRING "define project version")
set(BUILD_DOCS OFF CACHE BOOL "Generate doxygen-based documentation")

set(PROJECT_NAME dde-control-center)
project(${PROJECT_NAME}
    VERSION ${DVERSION}
    DESCRIPTION "Deepin Control Center"
    HOMEPAGE_URL "https://github.com/linuxdeepin/dde-control-center"
    LANGUAGES CXX C
)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(ENABLE_ASAN OFF)
option(BUILD_TESTING "UNIT test" OFF)
set(BUILD_EXAMPLES OFF)

# dcc-v23
set(BUILD_DCC_OLD OFF)
if (BUILD_DCC_OLD)
    add_subdirectory(dcc-old)
endif()

set(QT_NS Qt6)
set(DTK_NS Dtk6)
set(ASQT_NS AppStreamQt)

# 设置静态库文件目录
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 动态库文件目录
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
# 可执行文件目录
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)


# INFO:
# plugins can be disabled and their options
# plugin-authentication : DISABLE_AUTHENTICATION
# plugin-keyboard: DISABLE_LANGUAGE to disable language panel

option(DISABLE_AUTHENTICATION "disable build authentication plugins" OFF)
option(DISABLE_PRIVACY_PLUGIN "disable privacy and security plugin" OFF)
option(DISABLE_LANGUAGE "disable lanugage settings in control center" OFF)
option(USE_DEEPIN_ZONE "enable special timezone file on deepin" OFF)
option(DISABLE_SOUND_ADVANCED "disable sound advanced settings" OFF)
set(DEEPIN_TIME_ZONE_PATH "/usr/share/dde/zoneinfo/zone1970.tab" CACHE STRING "deepin timezone path")
set(LOCALE_I18N_PATH "/usr/share/i18n/SUPPORTED" CACHE STRING "Supported locale path")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/misc;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH};${PROJECT_SOURCE_DIR}/misc")
include(DdeControlCenterPluginMacros)

# asan 自己有内存泄露，暂不使用
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(UNITTEST ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Werror=return-type -fno-omit-frame-pointer -Wextra")
    if(ENABLE_ASAN)
        if (CMAKE_CXX_COMPILER_ID MATCHES "GNU"  OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -g")
            set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -g")
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
            set(CMAKE_LINKER_FLAGS "${CMAKE_LINKER_FLAGS} -fsanitize=address")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
            add_definitions(-DUSE_ASAN)
        endif()
    endif()
else()
    # generate qm
    execute_process(COMMAND bash "misc/translate_generation.sh" "${CMAKE_CURRENT_BINARY_DIR}/src/dde-control-center"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    # generate desktop translate
    execute_process(COMMAND bash "misc/translate_ts2desktop.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
endif()

if (BUILD_TESTING)
    set(UNITTEST ON)
endif()

set(BUILD_PLUGIN ON)

if (NOT BUILD_PLUGIN)
    set(UNITTEST OFF)
endif()
# GNU 默认

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(UT_COMPILER -fprofile-arcs -ftest-coverage)
elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
    set(UT_COMPILER -fprofile-instr-generate -ftest-coverage)
endif()

if (USE_DEEPIN_ZONE)
    add_definitions(-DUSE_DEEPIN_ZONE)
    add_definitions(-DDEEPIN_TIME_ZONE_PATH="${DEEPIN_TIME_ZONE_PATH}")
endif ()

add_definitions(-DLOCALE_I18N_PATH="${LOCALE_I18N_PATH}")

# 增加安全编译参数
set(POSITION_INDEPENDENT_CODE True)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

# Install settings
if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
include(GoogleTest)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif()

set(DCC_TRANSLATION_INSTALL_DIR "${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations/v1.0" CACHE STRING "Install dir for dde-control-center translate files")

# 输出目录
set(DCC_LIBDIR ${PROJECT_BINARY_DIR}/lib)
# 插件目录
set(DCC_PLUGINS_DIR plugins_v1.0)
# 安装目录
set(DCC_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/dde-control-center)
set(DCC_DEBUG_LIBDIR ${DCC_INSTALL_DIR})
set(DCC_TRANSLATE_READ_DIR ${CMAKE_INSTALL_PREFIX}/${DCC_TRANSLATION_INSTALL_DIR})

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(DCC_DEBUG_LIBDIR ${DCC_LIBDIR})
    set(DCC_TRANSLATE_READ_DIR ${PROJECT_BINARY_DIR}/src/dde-control-center)
endif()

add_definitions(-DTRANSLATE_READ_DIR="${DCC_TRANSLATE_READ_DIR}")
# 插件安装目录
set(DCC_PLUGINS_INSTALL_DIR ${DCC_DEBUG_LIBDIR}/${DCC_PLUGINS_DIR} CACHE STRING "Install dir for dde-control-center plugins")
# 插件读取目录
set(MODULE_READ_DIR "${DCC_DEBUG_LIBDIR}" CACHE STRING "Dir to find dde-control-center modules")
set(PLUGINS_READ_DIR "${DCC_PLUGINS_INSTALL_DIR}" CACHE STRING "Dir to find dde-control-center plugins")

GNUInstallDirs_get_absolute_install_dir(
    MODULE_READ_FULL_DIR
    MODULE_READ_DIR
    LIBDIR
)

GNUInstallDirs_get_absolute_install_dir(
    PLUGINS_READ_FULL_DIR
    PLUGINS_READ_DIR
    LIBDIR
)

message(STATUS ${MODULE_READ_FULL_DIR})
message(STATUS ${PLUGINS_READ_FULL_DIR})
message(STATUS ${DCC_PLUGINS_INSTALL_DIR})

add_definitions(-DDefaultModuleDirectory="${MODULE_READ_FULL_DIR}")
add_definitions(-DDefaultPluginsDirectory="${PLUGINS_READ_FULL_DIR}")

# DdeControlCenterPluginMacros.cmake 使用
set(DDE_CONTROL_CENTER_PLUGIN_DIR ${DCC_PLUGINS_DIR})
set(DDE_CONTROL_CENTER_TRANSLATION_INSTALL_DIR ${DCC_TRANSLATION_INSTALL_DIR})
set(DDE_CONTROL_CENTER_PLUGIN_INSTALL_DIR ${DCC_PLUGINS_INSTALL_DIR})

set(LOCALSTATE_READ_DIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}" CACHE STRING "Dir to find modifiable single-machine data")
set(DCC_PROJECT_ROOT_DIR ${CMAKE_CURRENT_SOURCE_DIR})
add_definitions(-DVARDIRECTORY="${LOCALSTATE_READ_DIR}")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(${DTK_NS} REQUIRED COMPONENTS Core Gui  )
find_package(${QT_NS} COMPONENTS Core Quick Gui Network DBus Concurrent Test LinguistTools Multimedia REQUIRED)
find_package(GTest REQUIRED)
find_package(Threads REQUIRED)

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif()

# dconfig
file(GLOB DCONFIG_FILES "misc/configs/*.json")
dtk_add_config_meta_files(APPID org.deepin.dde.control-center BASE misc/configs FILES ${DCONFIG_FILES})
file(GLOB DCONFIG_FILE_REGION_FORMAT "misc/configs/common/org.deepin.region-format.json")
dtk_add_config_meta_files(COMMONID true FILES ${DCONFIG_FILE_REGION_FORMAT})

include_directories(
    include
)

set(Test_Libraries
    -lgcov
    Threads::Threads
    GTest::gtest
    ${QT_NS}::Test
)

set(DCC_FRAME_Library dde-control-center_frame)

add_subdirectory(src/dde-control-center)
#--------------------------plugins--------------------------
add_subdirectory(src/plugin-accounts)
if (NOT DISABLE_AUTHENTICATION)
    add_subdirectory(src/plugin-authentication)
endif()
add_subdirectory(src/plugin-sound)
add_subdirectory(src/plugin-defaultapp)
add_subdirectory(src/plugin-power)
add_subdirectory(src/plugin-mouse)
add_subdirectory(src/plugin-personalization)
add_subdirectory(src/plugin-keyboard)
add_subdirectory(src/plugin-systeminfo)
add_subdirectory(src/plugin-commoninfo)
add_subdirectory(src/plugin-touchscreen)
add_subdirectory(src/plugin-datetime)
add_subdirectory(src/plugin-wacom)
add_subdirectory(src/plugin-bluetooth)
add_subdirectory(src/plugin-notification)
add_subdirectory(src/plugin-deepinid)
add_subdirectory(src/plugin-display)
if (NOT DISABLE_PRIVACY_PLUGIN)
    add_subdirectory(src/plugin-privacy)
endif()
add_subdirectory(src/plugin-dock)

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

if(UNITTEST)
    add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
set(BIN_NAME unit-test)

=== src/dde-control-center/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

#--------------------------frame--------------------------
set(DCCFrame_Name ${DCC_FRAME_Library})
file(GLOB DCCFrame_SRCS
    "${DCC_PROJECT_ROOT_DIR}/include/*.h"
    "frame/*.cpp"
    "frame/*.h"
)

add_library(${DCCFrame_Name} SHARED
    ${DCCFrame_SRCS}
)

find_package(${QT_NS} COMPONENTS QmlModels REQUIRED)
set(DCCFrame_Libraries
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${QT_NS}::QmlModelsPrivate
)

target_link_libraries(${DCCFrame_Name} PRIVATE
    ${DCCFrame_Libraries}
)

set_target_properties(${DCCFrame_Name} PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME dde-control-center
    EXPORT_NAME Control-Center
)

install(TARGETS ${DCCFrame_Name}
        EXPORT DdeControlCenterTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center
)

install(EXPORT DdeControlCenterTargets
        FILE DdeControlCenterTargets.cmake
        NAMESPACE Dde::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
)
#--------------------------qml-plugin--------------------------
add_subdirectory(frame/plugin)
#--------------------------dde-control-center--------------------------
set(Control_Center_Name dde-control-center)
file(GLOB Control_Center_SRCS
    "*.h"
    "*.cpp"
)
if (BUILD_DCC_OLD)
    add_library(${Control_Center_Name} SHARED
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
    set_target_properties(${Control_Center_Name} PROPERTIES
        OUTPUT_NAME dde-control-center-lib
    )
else()
    add_executable(${Control_Center_Name}
        ${Control_Center_SRCS}
        qrc/dcc.qrc
    )
endif()

target_compile_definitions(${Control_Center_Name} PRIVATE CVERSION="${CMAKE_PROJECT_VERSION}")

target_include_directories(${Control_Center_Name} PRIVATE
    include/interface
    frame
)

set(Control_Center_Libraries
    ${DCC_FRAME_Library}
    ${DTK_NS}::Gui
    ${QT_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
    ${QT_NS}::Quick
)

target_link_libraries(${Control_Center_Name} PRIVATE
    ${Control_Center_Libraries}
)

file(GLOB_RECURSE qmlFiles  "${DCC_PROJECT_ROOT_DIR}/qml/*.*")
add_custom_target(${Control_Center_Name}_qml ALL
    SOURCES ${qmlFiles}
)
add_custom_command(TARGET ${Control_Center_Name}_qml POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_directory "${DCC_PROJECT_ROOT_DIR}/qml" ${DCC_LIBDIR}
)

file(GLOB_RECURSE DCC_Translation_QML_FILES ${DCC_PROJECT_ROOT_DIR}/qml/*.qml ${DCC_PROJECT_ROOT_DIR}/src/*.qml)
file(GLOB_RECURSE DCC_Translation_SOURCE_FILES ${DCC_PROJECT_ROOT_DIR}/src/*.cpp ${DCC_PROJECT_ROOT_DIR}/src/*.h)
dcc_handle_plugin_translation(NAME ${Control_Center_Name} SOURCE_DIR ${DCC_PROJECT_ROOT_DIR} QML_FILES ${DCC_Translation_QML_FILES} SOURCE_FILES ${DCC_Translation_SOURCE_FILES})
# bin
if (BUILD_DCC_OLD)
    install(TARGETS ${Control_Center_Name} DESTINATION ${DCC_DEBUG_LIBDIR})
else()
    install(TARGETS ${Control_Center_Name} DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()
install(DIRECTORY "${DCC_PROJECT_ROOT_DIR}/qml/" DESTINATION ${DCC_INSTALL_DIR})
#----------------------------install config------------------------------
#desktop
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.control-center.desktop DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

#service
configure_file(
    ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.ControlCenter1.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
    @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.ControlCenter1.service
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services)

# systemd service
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

configure_file(
    ${CMAKE_SOURCE_DIR}/misc/systemd/dde-control-center.service.in
    ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
    @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.deepin.dde.control-center.service
        DESTINATION ${SYSTEMD_USER_UNIT_DIR})

# dev files
file(GLOB HEADERS "${DCC_PROJECT_ROOT_DIR}/include/*")
set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_INCLUDEDIR}/dde-control-center)
install(FILES ${HEADERS} DESTINATION ${INCLUDE_INSTALL_DIR})
if (BUILD_DCC_OLD)
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfigOld.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
else()
    configure_package_config_file(${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter
        PATH_VARS INCLUDE_INSTALL_DIR
        INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
endif()

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/DdeControlCenterConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES "${DCC_PROJECT_ROOT_DIR}/misc/DdeControlCenterPluginMacros.cmake" DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DdeControlCenter)

install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde.controlcenter.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

#dde-grand-search-daemon conf
install(FILES ${DCC_PROJECT_ROOT_DIR}/misc/org.deepin.dde-grand-search.dde-control-center-setting.conf
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/dde-grand-search-daemon/plugins/searcher)

=== src/plugin-datetime/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
set(pluginName datetime)
file(GLOB_RECURSE datetime_SRCS
    "operation/*.cpp"
    "operation/*.h"
    "operation/timezoneMap/*.h"
    "operation/timezoneMap/*.cpp"
    "operation/qrc/datetime.qrc"
)

add_library(${pluginName} MODULE
    ${datetime_SRCS}
)

find_package(ICU COMPONENTS i18n uc)

set(dateTime_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::DBus
    ${QT_NS}::Concurrent
     ${DTK_NS}::Gui
     ICU::i18n
     ICU::uc
)

target_link_libraries(${pluginName} PRIVATE
    ${dateTime_Libraries}
)

dcc_install_plugin(NAME ${pluginName} TARGET ${pluginName})

# keyboard_language_*.ts生成使用脚本misc/translate_language2ts.sh手动执行

=== src/plugin-display/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
###########################################
function(ws_generate_local type input_file output_name)
    pkg_get_variable(WAYLAND_SCANNER wayland-scanner wayland_scanner)
    execute_process(COMMAND ${WAYLAND_SCANNER}
        ${type}-header
        ${input_file}
        ${CMAKE_CURRENT_BINARY_DIR}/${output_name}.h
    )

    execute_process(COMMAND ${WAYLAND_SCANNER}
        public-code
        ${input_file}
        ${CMAKE_CURRENT_BINARY_DIR}/${output_name}.c
    )
endfunction()

find_package(PkgConfig REQUIRED)
pkg_check_modules(WaylandClient REQUIRED IMPORTED_TARGET wayland-client)

ws_generate_local(client
    ${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt/protocols/wlr-output-management-unstable-v1.xml
    wlr-output-management-unstable-v1-client-protocol)

ws_generate_local(client
    ${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt/protocols/treeland-output-management.xml
    treeland-output-management-client-protocol)

file(GLOB_RECURSE LIBWAYQT_SRCS
    "wayland/libwayqt/*.cpp"
    "wayland/libwayqt/*.hpp"
)

add_library(libwayqt6
    OBJECT
    ${LIBWAYQT_SRCS}
    wlr-output-management-unstable-v1-client-protocol.c
    treeland-output-management-client-protocol.c
)

# fix arm64 build failed relocation R_AARCH64_ADR_PREL_PG_HI21 against symbol
target_compile_options(libwayqt6 PRIVATE "-fpic")

target_include_directories(libwayqt6
    PUBLIC
        "${CMAKE_CURRENT_SOURCE_DIR}/wayland/libwayqt"
    PRIVATE
        ${Qt6Gui_PRIVATE_INCLUDE_DIRS}
)

target_link_libraries(libwayqt6
    PUBLIC
    ${QT_NS}::Core
    ${QT_NS}::Gui
    PkgConfig::WaylandClient
)
###########################################
set(Display_Name display)
file(GLOB_RECURSE Display_SRCS
    "operation/*.cpp"
)

add_library(${Display_Name} MODULE
    ${Display_SRCS}
)

target_include_directories(${Display_Name} PUBLIC
    $<TARGET_PROPERTY:libwayqt6,INTERFACE_INCLUDE_DIRECTORIES>
)

set(Display_Libraries
    ${DCC_FRAME_Library}
    ${QT_NS}::Gui
    ${QT_NS}::DBus
    ${QT_NS}::Quick
    ${DTK_NS}::Core
)

target_link_libraries(${Display_Name} PRIVATE
    ${Display_Libraries}
    $<TARGET_OBJECTS:libwayqt6>
    PkgConfig::WaylandClient
)

dcc_install_plugin(NAME ${Display_Name} TARGET ${Display_Name})
#########################################

=== src/dde-control-center/frame/plugin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

set(DCCQmlPlugin_Name dde-control-center-plugin)
set(URI "org.deepin.dcc")
string(REPLACE "." "/" URI_PATH ${URI})

file(GLOB DCCQmlPlugin_SRCS
    "src/*.h"
    "src/*.cpp"
)

file(GLOB QML_PATHS
    "*.qml"
    "*.js"
)

foreach(FILE_PATH ${QML_PATHS})
    string(REGEX REPLACE ".+/(.+)" "\\1" FILE_NAME ${FILE_PATH})
    list(APPEND DCCQmlPlugin_CONTROLS ${FILE_NAME})
endforeach(FILE_PATH)

qt_add_qml_module(${DCCQmlPlugin_Name}
    PLUGIN_TARGET ${DCCQmlPlugin_Name}
    URI ${URI}
    VERSION "1.0"
    SHARED
    NO_GENERATE_PLUGIN_SOURCE
    NO_PLUGIN_OPTIONAL
    QML_FILES
        ${DCCQmlPlugin_CONTROLS}
    SOURCES
        ${DCCQmlPlugin_SRCS}
    OUTPUT_DIRECTORY
        "${PROJECT_BINARY_DIR}/lib/${URI_PATH}"
)

target_include_directories(${DCCQmlPlugin_Name} PRIVATE
    include
)

set(DCCQmlPlugin_Libraries
    ${QT_NS}::Gui
    ${QT_NS}::Quick
    ${DCC_FRAME_Library}
)

target_link_libraries(${DCCQmlPlugin_Name} PRIVATE
    ${DCCQmlPlugin_Libraries}
)
# set(QML_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}/qt${QT_VERSION_MAJOR}/qml" CACHE STRING "Qml plugin install directory")
set(QML_INSTALL_DIR ${DCC_INSTALL_DIR})
install(DIRECTORY "${PROJECT_BINARY_DIR}/lib/${URI_PATH}/" DESTINATION "${QML_INSTALL_DIR}/${URI_PATH}/")

=== debian/changelog ===
dde-control-center (6.1.38) unstable; urgency=medium

  * i18n: Updates for project Deepin Desktop Environment (#2519)

 -- zhangkun <zhangkun2@uniontech.com>  Fri, 18 Jul 2025 15:08:00 +0800

dde-control-center (6.1.37) unstable; urgency=medium

  * fix: Update text errors
  * [dde-control-center] Updates for project Deepin Desktop Environment
    (#2512)
  * fix: Fixed Bluetooth device status not refreshing
  * fix: hide noise suppression setting when input device is bluetooth
  * fix: Modifying icons does not change with the theme

 -- zhangkun <zhangkun2@uniontech.com>  Fri, 18 Jul 2025 13:58:02 +0800

dde-control-center (6.1.36) unstable; urgency=medium

  * fix: Worng state in power anagement
  * fix: resolve keyboard layout addition failure
  * fix: Fix password error prompt issue
  * i18n: Updates for project Deepin Desktop Environment (#2500)
  * fix: resolve audio feedback issue when adjusting volume from 0% to
    100%
  * refactor: clean up QML properties and connections
  * fix: improve region selection menu styling and interaction
  * style: remove redundant textColor properties in DccWindow
  * fix: The issue of renaming user groups is fixed
  * fix: adjust text opacity in LangAndFormat for better visibility
  * fix: Fixed the Bluetooth speaker icon error
  * fix: Fixed the issue of customizing the avatar

 -- WuJiangYu <wujiangyu@uniontech.com>  Wed, 16 Jul 2025 10:47:37 +0800

dde-control-center (6.1.35) unstable; urgency=medium

  * i18n: Translate dde-control-center_en.ts in zh_TW
  * i18n: Translate dde-control-center_en.ts in zh_HK
  * i18n: Translate dde-control-center_en.ts in zh_CN
  * i18n: Translate dde-control-center_en.ts in hu
  * i18n: Translate dde-control-center_en.ts in fi
  * i18n: Translate dde-control-center_en.ts in pl
  * i18n: Translate dde-control-center_en.ts in sv
  * i18n: Translate dde-control-center_en.ts in az
  * i18n: Translate dde-control-center_en.ts in vi
  * i18n: Translate dde-control-center_en.ts in kab
  * i18n: Translate dde-control-center_en.ts in pt_BR
  * i18n: Translate dde-control-center_en.ts in zh_HK
  * i18n: Translate dde-control-center_en.ts in fr
  * i18n: Translate dde-control-center_en.ts in ko
  * i18n: Translate dde-control-center_en.ts in ru
  * i18n: Translate dde-control-center_en.ts in sl
  * i18n: Translate dde-control-center_en.ts in zh_CN
  * i18n: Translate dde-control-center_en.ts in gl_ES
  * i18n: Translate dde-control-center_en.ts in zh_TW
  * i18n: Translate dde-control-center_en.ts in th
  * i18n: Translate dde-control-center_en.ts in ja
  * i18n: Translate dde-control-center_en.ts in es
  * i18n: Translate dde-control-center_en.ts in sq
  * i18n: Translate dde-control-center_en.ts in ne
  * i18n: Translate dde-control-center_en.ts in uk
  * i18n: Translate dde-control-center_en.ts in kk
  * i18n: Translate dde-control-center_en.ts in de_DE
  * i18n: Translate dde-control-center_en.ts in bn
  * i18n: Translate dde-control-center_en.ts in ca
  * i18n: Translate dde-control-center_en.ts in tr
  * i18n: Translate dde-control-center_en.ts in he
  * i18n: Translate dde-control-center_en.ts in et
  * i18n: Translate dde-control-center_en.ts in ar
  * feat: add locale generation support and UI indicators
  * fix: resolve missing number format in region settings
  * i18n: Translate dde-control-center_en.ts in zh_CN
  * i18n: Translate dde-control-center_en.ts in zh_TW
  * i18n: Translate dde-control-center_en.ts in zh_HK
  * i18n: Translate dde-control-center_en.ts in ru
  * i18n: Translate dde-control-center_en.ts in kk
  * i18n: Translate dde-control-center_en.ts in kab
  * i18n: Translate dde-control-center_en.ts in sq
  * i18n: Translate dde-control-center_en.ts in fr
  * i18n: Translate dde-control-center_en.ts in de_DE
  * i18n: Translate dde-control-center_en.ts in zh_CN
  * i18n: Translate dde-control-center_en.ts in he
  * i18n: Translate dde-control-center_en.ts in th
  * i18n: Translate dde-control-center_en.ts in vi
  * i18n: Translate dde-control-center_en.ts in ne
  * i18n: Translate dde-control-center_en.ts in pt_BR
  * i18n: Translate dde-control-center_en.ts in bn
  * i18n: Translate dde-control-center_en.ts in hu
  * i18n: Translate dde-control-center_en.ts in ca
  * i18n: Translate dde-control-center_en.ts in fi
  * i18n: Translate dde-control-center_en.ts in uk
  * i18n: Translate dde-control-center_en.ts in pl
  * i18n: Translate dde-control-center_en.ts in gl_ES
  * i18n: Translate dde-control-center_en.ts in sl
  * i18n: Translate dde-control-center_en.ts in tr
  * i18n: Translate dde-control-center_en.ts in az
  * i18n: Translate dde-control-center_en.ts in zh_HK
  * i18n: Translate dde-control-center_en.ts in et
  * i18n: Translate dde-control-center_en.ts in es
  * i18n: Translate dde-control-center_en.ts in zh_TW
  * i18n: Translate dde-control-center_en.ts in sv
  * i18n: Translate dde-control-center_en.ts in ko
  * i18n: Translate dde-control-center_en.ts in ja
  * i18n: Translate dde-control-center_en.ts in ar
  * fix: improve nickname modification handling and validation
  * i18n: Updates for project Deepin Desktop Environment (#2491)
  * fix: Unprocessed screen scaling
  * fix: Fixed the issue of right-clicking to exit editing
  * fix: Modify the schematic diagram style
  * fix: The issue of creating a new user prompt is fixed
  * fix: Fixed the sorting issue of Bluetooth devices
  * [dde-control-center] Updates for project Deepin Desktop Environment
    (#2470)
  * feat: implement avatar caching system
  * fix: Fixed the dynamic display in Security Center
  * fix: hide balance control for handsfree devices
  * fix: prevent bottom button occlusion in RegionFormatDialog
  * fix: prevent scrollbar overflow in region selection dropdown
  * fix: Volume adjustment display issue Update font size and add
    transparency to volume percentage labels
  * fix: Fix file prompts that are not supported
  * fix: fix region and format panel layout in TimeAndDate dialog


=== debian/control ===
Source: dde-control-center
Section: admin
Priority: optional
Maintainer: Deepin Sysdev <sysdev@deepin.com>
Build-Depends:
 debhelper-compat (= 12),
 pkg-config,
 cmake,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-tools-dev,
 qt6-declarative-private-dev,
 qt6-multimedia-dev,
 libpolkit-qt6-1-dev,
 libdtkcommon-dev,
 libdtk6gui-dev(>=6.0.21),
 libdtk6core-dev,
 libdtk6core-bin,
 doxygen,
 libgtest-dev,
 extra-cmake-modules,
 libqt6svg6,
 deepin-gettext-tools,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qt6-wayland-dev,
 qt6-wayland-private-dev,
 qt6-wayland-dev-tools,
 treeland-protocols(>=0.4.1),
 systemd,
 libdareader-dev,
 libdeepin-pw-check-dev,
 libicu-dev,
 libwayland-dev,
 libssl-dev,
 libdde-shell-dev(>= 1.99.20),
 libdpkg-dev
Standards-Version: 4.5.0
Homepage: https://github.com/linuxdeepin/dde-control-center

Package: dde-control-center
Architecture: any
Depends:
 ${shlibs:Depends}, ${misc:Depends},
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 qml6-module-qt-labs-qmlmodels,
 qml6-module-qtquick-dialogs,
 qml6-module-qtquick-effects,
 libdtk6declarative,
 netselect,
Conflicts: dde-control-center-dock
Replaces: dde-control-center-dock
Description: New control center for Deepin Desktop Environment,
 Integrated control center with rich functions,Besides providing rich
 system setting items, the function level is simple, the logic is clear,
 the user can easily set the system, and the learning cost is low,
 Provide users with automatic update system and developer mode to meet
 the various needs of users for the operating system.
 abrecovery -restore system, Determine whether the system is restored
 reboot-reminder-dialog -Update restart, Confirm whether to restart the system
 after the completion of the update.
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-dev
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: New control center for Deepin Desktop Environment - development files
 DDE Control Center is the control panel of Deepin Desktop Environment.

Package: dde-control-center-doc
Architecture: any
Depends: dde-control-center (= ${binary:Version}), ${misc:Depends}
Description: dde-control-center (document)
 This package contains the doc files of dde-control-center

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/default.mk
export QT_SELECT = qt6
VERSION = $(DEB_VERSION_UPSTREAM)
PACK_VER = $(shell echo $(VERSION) | awk -F'[+_~-]' '{print $$1}')

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -Wl,-E
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -Wl,-E
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack

%:
	dh $@ --parallel
override_dh_auto_configure:
	dh_auto_configure -- -DCVERSION=$(DEB_VERSION_UPSTREAM) -DDVERSION=$(PACK_VER) -DUSE_DEEPIN_ZONE=ON

## dde-control-center 6.1.43

=== CMakeLists.txt ===
--- 
+++ 
@@ -199,6 +199,8 @@
 set(DCC_FRAME_Library dde-control-center_frame)
 
 add_subdirectory(src/dde-control-center)
+#-----------------------shared-utils------------------------
+add_subdirectory(src/shared-utils)
 #--------------------------plugins--------------------------
 add_subdirectory(src/plugin-accounts)
 if (NOT DISABLE_AUTHENTICATION)

=== debian/changelog ===
dde-control-center (6.1.43) unstable; urgency=medium

  * fix: update region format config flags
  * chore: update desktop translation
  * i18n: Updates for project Deepin Desktop Environment (#2573)
  * fix: adjust notification UI alignment
  * fix: improve input field UI consistency
  * fix: adjust password layout spacing and margins
  * fix: improve shortcut conflict text display
  * fix: improve Bluetooth UI state handling during power toggle
  * fix: improve shortcut dialog text consistency
  * fix: bluetooth device list auto-refresh after power toggle (#2567)

 -- zhangkun <zhangkun2@uniontech.com>  Thu, 14 Aug 2025 20:46:50 +0800

dde-control-center (6.1.42) unstable; urgency=medium

  * fix: improve bluetooth mode selection stability (#2564)
  * i18n: Updates for project Deepin Desktop Environment (#2558)
  * fix: round margin values to prevent subpixel blurring

 -- wujiangyu <wujiangyu@uniontech.com>  Tue, 12 Aug 2025 10:38:51 +0800

dde-control-center (6.1.41) unstable; urgency=medium

  * fix: improve gesture action data handling
  * i18n: Updates for project Deepin Desktop Environment (#2552)
  * fix: Created successfully with the same username and password
  * fix: add focus support for SearchableListViewPopup

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 07 Aug 2025 20:52:06 +0800

dde-control-center (6.1.40) unstable; urgency=medium

  * fix: unsupported relocation error on arm64

 -- Wang Zichong <wangzichong@deepin.org>  Fri, 01 Aug 2025 11:08:00 +0800

dde-control-center (6.1.39) unstable; urgency=medium

  * chore: remove upper-level datetime_*.ts resources
  * fix: Modify the translation of Scaling
  * i18n: Updates for project Deepin Desktop Environment (#2549)
  * fix: update double click speed slider labels
  * style: adjust datetime plugin UI elements
  * fix: remove unnecessary trim in Bluetooth device name validation
  * fix: Cursor display jumps add text measurement and auto-alignment
    for text field
  * i18n: Updates for project Deepin Desktop Environment (#2545)
  * fix: remove unused QString to UnicodeString convert
  * fix: remove the need of `datetime_language.ts` and
    `datetime_country.ts`
  * i18n: Updates for project Deepin Desktop Environment (#2543)
  * chore: update ts files
  * i18n: Translate dde-control-center_en.ts in es (#2541)
  * fix: remove the need of `keyboard_language.ts` resources
  * i18n: Updates for project Deepin Desktop Environment (#2521)
  * fix: add fallback for empty app icons in notification plugin
  * fix: show shortcut keys in edit mode
  * refactor: remove redundant textColor property in NativeInfoPage
  * fix: allow saving shortcuts with modifier-only keys
  * feat: adjust notification combo box width
  * fix: Fixed the issue of incomplete display of large fonts
  * fix: Modify search error issues
  * fix: Modify the schematic diagram style
  * fix: resolve active color inconsistency in timezone menu popup
  * fix: Change the size of the hover background
  * fix: Fixed the issue of pop-up theme mismatch
  * fix: resolve theme adaptation issues in RegionsChooserWindow dark
    mode
  * fix: resolve cancel operation in shortcut setting dialog
  * fix: Fix mailbox errors
  * fix: Fix the startup screen
  * fix: reset view position when searching in RegionFormatDialog
  * fix: resolve empty region list after clearing search input
  * fix: The error message is fixed

 -- YeShanShan <yeshanshan@uniontech.com>  Thu, 31 Jul 2025 19:42:46 +0800
